Bug 1305439 - (CVE-2016-2194, CVE-2016-2195, CVE-2016-2196) CVE-2016-2196 CVE-2016-2195 CVE-2016-2194 botan: various flaws fixed in 1.11.27 and 1.10.11
CVE-2016-2196 CVE-2016-2195 CVE-2016-2194 botan: various flaws fixed in 1.11....
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
impact=important,public=20160201,repo...
: Security
Depends On: 1305440 1305441
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-08 04:33 EST by Martin Prpič
Modified: 2016-12-02 04:09 EST (History)
1 user (show)

See Also:
Fixed In Version: botan 1.11.27, botan 1.10.11
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-02 04:09:03 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Martin Prpič 2016-02-08 04:33:43 EST
2016-02-01 (CVE-2016-2196): Overwrite in P-521 reduction

The P-521 reduction function would overwrite zero to one word following the allocated block. This could potentially result in remote code execution or a crash. Found with AFL

Introduced in 1.11.10, fixed in 1.11.27

2016-02-01 (CVE-2016-2195): Heap overflow on invalid ECC point

The PointGFp constructor did not check that the affine coordinate arguments were less than the prime, but then in curve multiplication assumed that both arguments if multiplied would fit into an integer twice the size of the prime.

The bigint_mul and bigint_sqr functions received the size of the output buffer, but only used it to dispatch to a faster algorithm in cases where there was sufficient output space to call an unrolled multiplication function.

The result is a heap overflow accessible via ECC point decoding, which accepted untrusted inputs. This is likely exploitable for remote code execution.

On systems which use the mlock pool allocator, it would allow an attacker to overwrite memory held in secure_vector objects. After this point the write will hit the guard page at the end of the mmap’ed region so it probably could not be used for code execution directly, but would allow overwriting adjacent key material.

Found by Alex Gaynor fuzzing with AFL

Introduced in 1.9.18, fixed in 1.11.27 and 1.10.11

2016-02-01 (CVE-2016-2194): Infinite loop in modulur square root algorithm

The ressol function implements the Tonelli-Shanks algorithm for finding square roots could be sent into a nearly infinite loop due to a misplaced conditional check. This could occur if a composite modulus is provided, as this algorithm is only defined for primes. This function is exposed to attacker controlled input via the OS2ECP function during ECC point decompression. Found by AFL

Introduced in 1.7.15, fixed in 1.11.27 and 1.10.11

External References:

http://botan.randombit.net/security.html#id1
Comment 1 Martin Prpič 2016-02-08 04:34:08 EST
Created botan tracking bugs for this issue:

Affects: fedora-all [bug 1305440]
Affects: epel-all [bug 1305441]
Comment 2 Fedora Update System 2016-02-23 14:22:22 EST
botan-1.10.12-1.fc23, code-editor-2.8.1-13.fc23, monotone-1.1-13.fc23, qca-2.1.1-4.fc23, qt-creator-3.6.0-6.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 3 Fedora Update System 2016-02-29 17:21:05 EST
botan-1.10.12-1.fc22, code-editor-2.8.1-13.fc22, monotone-1.1-13.fc22, qca-2.1.1-4.fc22, qt-creator-3.6.0-6.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.
Comment 4 Fedora Update System 2016-03-02 15:01:06 EST
botan-1.10.12-1.el7, qt-creator-3.5.1-2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.
Comment 5 Fedora Update System 2016-03-03 13:23:39 EST
botan-1.8.15-1.el5 has been pushed to the Fedora EPEL 5 stable repository. If problems still persist, please make note of it in this bug report.
Comment 6 Fedora Update System 2016-03-03 14:57:02 EST
botan-1.8.15-1.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.
Comment 7 Thomas Moschny 2016-04-29 14:36:59 EDT
Should be closed.

Note You need to log in before you can comment on or make changes to this bug.